function [en,diff] = compute_err(qmesh,xcenter,ycenter,zcenter,...
    dx,dy,dz,mcapa,t,err_norm,level,Frame)

global OutputFlag;

[xcm,ycm,zcm] = meshgrid(xcenter,ycenter,zcenter);
[xpm,ypm,zpm] = mapc2p(xcm,ycm,zcm);

dir = './qref_chombo/qref_fine/';
[q1d,t1d] = readamrdata(1,Frame,dir);
if (abs(t - t1d) > 1e-8)
  disp(dir);
  disp(Frame)
  disp([t t1d]);
  error('compute_err : Times are not compatible');
end;
mx = q1d.mx;
xlow = q1d.xlow;
dx1d = q1d.dx;
xedge = xlow + (0:mx)*dx1d;
xcenter = xedge(1:mx) + dx1d/2;
qcm = interp1(xcenter',q1d.data(1,:)',xpm,'linear');

mask = 1;

area = sum(sum(sum(mcapa.*mask)))*dx*dy*dz;
fprintf('Volume = %24.16f\n',area);

diff = abs(qcm - qmesh);

en(1)= err_norm(1) + sum(sum(sum(diff.*mcapa)))*dx*dy*dz/area;
en(2) = err_norm(2) + sum(sum(sum((diff.^2).*mcapa)))*dx*dy*dz/area;
en(3) = max([max(max(max(diff))) err_norm(3)]);
