close all
clear all


fmax = input('Input number of plots to create : ');


prob = 'Plane wave';

% --------------------------------
n = 1;

pstr= {'1-norm','2-norm','Inf-norm'};
psym = {'+','go','x','s'};


ncol = 1;
xlen = 1;
data_col = 2:4;

r = cell(0);
leg_str = cell(0);
eoc = [];
phdl = cell(0);

nmin = [];
n_min = 2000;
n_max = 0;
fid = fopen('strings.dat','w');
for n = 1:fmax,
  fname = input(sprintf('Input error file %d : ',n),'s');
  plt_norm = input('Input norm(s) to plot : ');
  nmin = input('Input minimum n : ');
  idot = findstr(fname,'.out');
  if (~isempty(idot))
    varname = fname(1:idot-1);
  else
    varname = fname((sdot+1):end);
  end;

  eval(['load ',fname]);
  eval(['err = ',varname,';']);
  nvec = err(:,ncol);
  n_min = min([nvec;n_min]);
  n_max = max([nvec;n_max]);
  hvec = xlen./nvec;

  figure(1);
  hold on;

  [r{n},eoc(n),phdl{n}] = rates(err(:,data_col),hvec,plt_norm,nvec,psym{n},nmin);

  ls = input('Input legend string : ','s');
  leg_str{n} = sprintf('%s : rates = %6.2f',ls,eoc(n));
  fprintf('\n');
  fprintf(fid,'%s\n',pwd);
  fprintf(fid,'%s; nmin = %d; norm = %d\n\n',fname,nmin,plt_norm);
end;
fclose(fid);

tk = xlen./get(gca,'XTick');
tklabel = cell(length(tk),1);
for i = 0:length(tk)-1,
  if (mod(i,1) == 0)
    tklabel{i+1} = num2str(tk(i+1));
  else
    tklabel{i+1} = '';
  end;
end;


set(gca,'XTickLabel',tklabel);

% Get handles for data plot (not slope plot).
for j = 1:length(phdl),
  pv(j) = phdl{j}(1);
end;

% Set up legend
set(pv,'LineWidth',2);
lh = legend(pv,leg_str,2);
set(lh,'FontSize',16);

% Set up title and axes labels.
str = sprintf('%s convergence rates for plane wave example',pstr{plt_norm});
th = title(str,'FontSize',16);
set(th,'FontSize',16);
xlabel('Grid size (in x direction)','FontSize',16);
ylabel('Error','FontSize',16);
set(gca,'FontSize',14);

% print_labels;
