/* _______              __
  / ___/ /  ___  __ _  / /  ___
 / /__/ _ \/ _ \/  ' \/ _ \/ _ \
 \___/_//_/\___/_/_/_/_.__/\___/ 
*/

// timeInterp.H

//
// This software is copyright (C) by the Lawrence Berkeley
// National Laboratory.  Permission is granted to reproduce
// this software for non-commercial purposes provided that
// this notice is left intact.
// 
// It is acknowledged that the U.S. Government has rights to
// this software under Contract DE-AC03-765F00098 between
// the U.S.  Department of Energy and the University of
// California.
//
// This software is provided as a professional and academic
// contribution for joint exchange. Thus it is experimental,
// is provided ``as is'', with no warranties of any kind
// whatsoever, no support, no promise of updates, or printed
// documentation. By using this software, you acknowledge
// that the Lawrence Berkeley National Laboratory and
// Regents of the University of California shall have no
// liability with respect to the infringement of other
// copyrights by any part of this software.
//
// Dan Martin, Fri, Jan 14, 2000

#ifndef _timeInterp_H_
#define _timeInterp_H_

#include "LevelData.H"
#include "FArrayBox.H"
#include "Interval.H"

/// interpolate data in time -- assumes one-to-one correspondence in comps
void
timeInterp(LevelData<FArrayBox>& a_dest, Real a_time,
	   const LevelData<FArrayBox>& a_old_phi, Real a_old_time,
	   const LevelData<FArrayBox>& a_new_phi, Real a_new_time,
	   const Interval& a_comps);

/// interpolate data in time -- dest comps can be misaligned with src comps
void
timeInterp(LevelData<FArrayBox>& a_dest, Real a_time,
	   const LevelData<FArrayBox>& a_old_phi, Real a_old_time,
	   const LevelData<FArrayBox>& a_new_phi, Real a_new_time,
	   const Interval& a_src_comps, const Interval& a_dest_comps);


#endif


