#include "Timer.H"
extern Timer Everything;
extern Timer TimeTSadvance; // in AMR.cpp

Timer TimeLevelGodunovStep("LevelGodunovStep", TimeTSadvance, 176);

Timer TimeLGtemporaryStorage     ("tempStorage",     TimeLevelGodunovStep);
Timer TimeLGfillInterp           ("fillInterp",      TimeLevelGodunovStep);
Timer TimeLGupdateState          ("updateState",     TimeLevelGodunovStep, 178);
Timer TimeLGincrementFluxRegister("inc flux reg",    TimeLevelGodunovStep);
Timer TimeLGtempBarrier          ("temp Barrier",    TimeLevelGodunovStep);
Timer TimeLGcopyUandAllreduce    ("copyU Allreduce", TimeLevelGodunovStep);

Timer TimeUpstateCopyTempStorage    ("copy temp stor",  TimeLGupdateState);
Timer TimeUpstateAllocateFluxStorage("Alloc Flux Sto",  TimeLGupdateState);
Timer TimeUpstateComputeFluxes      ("computeFluxes",   TimeLGupdateState);
Timer TimeUpstateFinalUpdate        ("finalUpdate",     TimeLGupdateState);
Timer TimeUpstateMaxWaveSpeed       ("getMaxWaveSpeed", TimeLGupdateState);

// have to make this guy a seperate table cuz the INS code calls from diff places
Timer TimecomputeFluxesAll("computeFluxes", 250);
Timer TimecFluxesInit               ("Init",            TimecomputeFluxesAll);
Timer TimecFluxesconsToPrim         ("consToPrim",      TimecomputeFluxesAll);
Timer TimecFluxesComputeFlattening  ("comp Flattening", TimecomputeFluxesAll);
Timer TimecFluxesResize             ("resize FABs",     TimecomputeFluxesAll);
Timer TimecFluxesSlope              ("slope",           TimecomputeFluxesAll);
Timer TimecFluxesNormalPred         ("normalPred",      TimecomputeFluxesAll);
Timer TimecFluxesIncrementWithSource("incWithSource",   TimecomputeFluxesAll);
Timer TimecFluxesRiemann            ("Riemann",         TimecomputeFluxesAll);
Timer TimecFluxesFluxBC             ("fluxBC",          TimecomputeFluxesAll);
Timer TimecFluxesCopy3D             ("copy for 3D",     TimecomputeFluxesAll);
Timer TimecFluxesUpdatePrim         ("updatePrim",      TimecomputeFluxesAll);
Timer TimecFluxesRiemann3D          ("Riemann for 3D",  TimecomputeFluxesAll);
Timer TimecFluxesFluxBC3D           ("fluxBC for 3D",   TimecomputeFluxesAll);
Timer TimecFluxesUpdatePrimFinal    ("updatePrim final",TimecomputeFluxesAll);
Timer TimecFluxesRiemannFinal       ("Riemann final",   TimecomputeFluxesAll);
Timer TimecFluxesFluxBCFinal        ("fluxBC final",    TimecomputeFluxesAll);
Timer TimecFluxesArtificialViscosity("art viscosity",   TimecomputeFluxesAll);


Timer TMPI_LGstep_cp1                 ("stepa_U cp",      Everything, DTIMECOMM, true);
Timer TMPI_LGstep_broadcast           ("step bc",         Everything, DTIMECOMM, true);
Timer TMPI_LGAllreduce                ("step Allreduce",  Everything, DTIMECOMM, true);
Timer TMPI_LGgetMaxWaveSpeed_gather   ("maxspeed gather", Everything, DTIMECOMM, true);
Timer TMPI_LGgetMaxWaveSpeed_broadcast("maxspeed bc",     Everything, DTIMECOMM, true);
Timer TMPI_gov_computeSum_Allreduce   ("gov compSum Allr",Everything, DTIMECOMM, true);

Timer TF_GETGRAD         ("GETGRAD",        Everything, DTIMEFORT, true);
Timer TF_GETDPTWO        ("GETDPTWO",       Everything, DTIMEFORT, true);
Timer TF_MIN3PTS         ("MIN3PTS",        Everything, DTIMEFORT, true);
Timer TF_GETFLAT         ("GETFLAT",        Everything, DTIMEFORT, true);
Timer TF_MINFLAT         ("MINFLAT",        Everything, DTIMEFORT, true);
Timer TF_SECONDSLOPEDIFFS("2ndSLOPEDIFFS",  Everything, DTIMEFORT, true);
Timer TF_FOURTHSLOPEDIFFS("4thSLOPEDIFFS",  Everything, DTIMEFORT, true);
Timer TF_APPLYFLAT       ("APPLYFLAT",      Everything, DTIMEFORT, true);
Timer TF_ARTVISC         ("ARTVISC",        Everything, DTIMEFORT, true);
Timer TF_VANLEERLIMITER  ("VANLEERLIMITER", Everything, DTIMEFORT, true);
Timer TF_DIVUEDGE        ("DIVUEDGE",       Everything, DTIMEFORT, true);
