C -*- Mode: Fortran; -*-
c-----------------------------------------------------------------
c       Ravi Samtaney
c       Copyright 2001
c       Princeton Plasma Physics Laboratory
c       All Rights Reserved
c-----------------------------------------------------------------
c       $Log: init2.F,v $
c       Revision 1.4  2004/11/23 00:54:17  noel
c       Trying to keep in-line with repo
c
c       Revision 1.1  2002/06/13 22:16:18  samtaney
c       Original unsplit 8-wave Ideal MHD source (includes B filter).
c
c-----------------------------------------------------------------
c Subroutine to set up the initial conditions
c---------------------------------------------------------------------------
c
c----------------------------------------------------------------------
       subroutine ReconInitialConditions(ux,ilo,ihi,jlo,jhi,
     &                     klo,khi,
     &                     adx,ady,adz)
c----------------------------------------------------------------------
c
	use properties
	use mesh
c=======Declarations=========
	integerilo,ihi,jlo,jhi,klo,khi
c	real*8 ux(ilo-nghost:ihi+nghost,
c     &                        jlo-nghost:jhi+nghost,
c     &                        1:1,nvar)
	real*8 ux(ilo:ihi,
     &                        jlo:jhi,
     &                        1:1,nvar)
c     &                        klo-nghost:khi+nghost,nvar)
c
	real*8 psi(ilo-nghost:ihi+nghost,
     &                        jlo-nghost:jhi+nghost,
     &                        1:1)
c	real*8 psi(ilo:ihi,
c     &                        jlo:jhi,
c     &                        1:1)
c     &                        klo-nghost:khi+nghost)
        real*8 adx,ady,adz
	integer i,j,k,l
	real*8 dtodx,dtody
        real*8 rho,press, Bi, Bj, Bk, u,v,w
        real*8 dxi,dyi
        real*8 xl,yl,xr,yr
c
	integer i,j,k
        real*8 x,y,z
        real*8 pi, kx,ky,lamda
c
	gamma=1.4D0
	rgas=8317.D0
	wmol=1.D0
	mu=1.D-03
	eta=1.D-03
	kappa=1.D-03
c
        xl=-1.0D0
        xr=1.D0
        yl=0.D0
c        yr=0.5D0
        yr=1.D0
c
	pi=4.D0*datan(1.D0)
        dxi=0.5D0/adx
        dyi=0.5D0/ady
c
        rho=1.D0
        press=0.2D0
	u=0.D0
	v=0.D0
	w=0.D0
c
	kx=3.D0*pi/2.D0
	ky=pi
c	kx=3.D0*pi
c	ky=4.D0*pi
	lamda=dsqrt(kx*kx+ky*ky)
c        
c        do k=klo,khi,1
c           do j=jlo-1,jhi+1,1
c              y = yl+(j - 0.5D0)*ady;
c              do i=ilo-1,ihi+1,1
c                 x = xl+(i - 0.5D0)*adx;
c                 psi(i,j,k)=cos(kx*x)*sin(ky*y)
c              enddo
c           enddo
c        enddo
c
c$$$        do k=klo,khi,1
c$$$           do j=jlo,jhi,1
c$$$              y = yl+(j - 0.5D0)*ady;
c$$$              do i=ilo,ihi,1
c$$$                 x = xl+(i - 0.5D0)*adx;
c$$$                 write(11,*) x,y,psi(i,j,k)
c$$$              enddo
c$$$              write(11,*) 
c$$$           enddo
c$$$        enddo
c
c        call flush(11)
        do k=klo,khi,1
           do j=jlo,jhi,1
              y = yl+(j - 0.5D0)*ady;
              do i=ilo,ihi,1
                 x = xl+(i - 0.5D0)*adx;
		 Bi=-ky*cos(kx*x)*cos(ky*y)
		 Bj=-kx*sin(kx*x)*sin(ky*y)
c                 Bi=-(psi(i,j+1,k)-psi(i,j-1,k))*dyi
c                 Bj=(psi(i+1,j,k)-psi(i-1,j,k))*dxi
		 Bk=-lamda*cos(kx*x)*sin(ky*y)
c		 if(cos(kx*x)*sin(ky*y).gt.0.D0) then
c                    Bi=0.1*Bi; Bj=0.1*Bj; Bk=0.1*Bk;
c                    Bi=0.D0; Bj=0.D0; Bk=0.D0
c                 endif
                 ux(i,j,k,1)=rho
                 ux(i,j,k,2)=rho*u
                 ux(i,j,k,3)=rho*v
                 ux(i,j,k,4)=rho*w
                 ux(i,j,k,5)=Bi
                 ux(i,j,k,6)=Bj
                 ux(i,j,k,7)=Bk
                 ux(i,j,k,8)=press/(gamma-1.D0)+
     &                0.5*rho*(u*u+v*v+w*w)+0.5D0*(bi*bi+bj*bj+bk*bk)
                 ux(i,j,k,9)=-cos(kx*x)*sin(ky*y)
              enddo
           enddo
        enddo
c        ux(:,:,:,9)=psi(ilo:ihi,jlo:jhi,:)
c     
      return
      end







