C -*- Mode: Fortran; -*-
c-----------------------------------------------------------------
c       Ravi Samtaney
c       Copyright 2002
c       Princeton Plasma Physics Laboratory
c       All Rights Reserved
c-----------------------------------------------------------------
c       $Log: newdt.F,v $
c       Revision 1.4  2004/11/23 00:54:17  noel
c       Trying to keep in-line with repo
c
c       Revision 1.2  2002/07/09 19:00:59  samtaney
c       Intermediate commit of files towards a single 2D/3D Ideal MHD code.
c
c       Revision 1.1  2002/06/13 22:16:18  samtaney
c       Original unsplit 8-wave Ideal MHD source (includes B filter).
c
c-----------------------------------------------------------------
       subroutine maxWaveSpeedMHD(cmax,ux,iulo,iuhi,julo,juhi,
     &                    kulo,kuhi,
     &                    ilo,ihi,jlo,jhi,
     &                     klo,khi)
c----------------------------------------------------------------------
c
      implicit none
c
#include  "EosCommon.fh"
c
c     Incoming arguments
        integer iulo,iuhi,julo,juhi,kulo,kuhi
	integer ilo,ihi,jlo,jhi,klo,khi
        real*8 cmax
	real*8 ux(iulo:iuhi,
     &            julo:juhi,
     &            kulo:kuhi,8)
c     &            1:1,8)
c       
c     Local variables
	real*8 rho
	real*8 u,v,w,press
	real*8 bi,bj,bk
	real*8 rhoInv
	real*8 Asq
	real*8 axsq,aysq,azsq
	real*8 csndsq
	real*8 cfastx,cfasty,cfastz
c	real*8 cslowx,cslowy,cslowz
	real*8 csnd,wavespeedx,wavespeedy,wavespeedz
	real*8 tmp,tmpx,tmpy,tmpz
	integer i,j,k

#if CH_SPACEDIM==2
        write(6,*) 'MAXWAVE SPEED in 2D'
#elif CH_SPACEDIM==3
        write(6,*) 'MAXWAVE SPEED in 3D'
#endif
c       compute maximum velocity and adjust time step to satisfy
c       cfl criterion
	do k = klo,khi
           do j = jlo,jhi
              do i = ilo,ihi
                 rho = ux(i,j,k,1)
                 u = ux(i,j,k,2)/rho
                 v = ux(i,j,k,3)/rho
                 w = ux(i,j,k,4)/rho
		 bi=ux(i,j,k,5)
		 bj=ux(i,j,k,6)
		 bk=ux(i,j,k,7)
		 rhoInv=1.D0/ux(i,j,k,1)
		 press=(gamma-1.D0)*(ux(i,j,k,8)-0.5D0*rho
	1	      *(u*u+v*v+w*w)-0.5D0*(bi*bi+bj*bj+bk*bk))
c       
		 axsq=bi**2*rhoInv
		 aysq=bj**2*rhoInv
		 azsq=bk**2*rhoInv
		 Asq=(bi**2+bj**2+bk**2)*rhoInv
		 csndsq=gamma*press*rhoInv
		 tmpx=dsqrt(dmax1(((csndsq+Asq)**2-4.0*csndsq*axsq),
	1	      0.D0))
		 tmpy=dsqrt(dmax1(((csndsq+Asq)**2-4.0*csndsq*aysq),
	1	      0.D0))
c		 tmpz=dsqrt(dmax1(((csndsq+Asq)**2-4.0*csndsq*azsq),
c	1	      0.D0))
		 tmp=csndsq+Asq
		 cfastx=dsqrt(0.5*(tmp+tmpx))
c		 cslowx=dsqrt(0.5*(tmp-tmpx))
		 cfasty=dsqrt(0.5*(tmp+tmpy))
c		 cslowy=dsqrt(0.5*(tmp-tmpy))
c		 cfastz=dsqrt(0.5*(tmp+tmpz))
c		 cslowz=dsqrt(0.5*(tmp-tmpz))
		 csnd=dsqrt(csndsq)
c		 waveSpeed=dmax1(cfast,cslow,dsqrt(axsq))
c		 waveSpeedx=dmax1(cfastx,dsqrt(axsq))
		 waveSpeedy=cfasty
		 waveSpeedx=cfastx
c		 waveSpeedy=dmax1(cfasty,dsqrt(aysq))
c		 waveSpeedz=dmax1(cfastx,dsqrt(azsq))
c$$$                 xspmax = dmin1(xspmax,dx/(dabs(u)
c$$$     &                +waveSpeedx))
c$$$                 yspmax = dmin1(yspmax,dy/(dabs(v)
c$$$     &                +waveSpeedy))
c                 zspmax = dmin1(zspmax,dz/(dabs(w)
c     &                +waveSpeed))
c                 dt_local = dmin1(xspmax,yspmax,zspmax)*cfl
                 cmax = dmax1(waveSpeedx,waveSpeedy)
c
              enddo
           enddo
        enddo
	return
	end



