#include "Timer.H"
extern Timer Everything;
extern Timer TimeTSadvance;

Timer TimeLevelGodunovStep("LevelGodunovStep", TimeTSadvance, 176);

Timer TimeLGtemporaryStorage     ("tempStorage",     TimeLevelGodunovStep);
Timer TimeLGfillInterp           ("fillInterp",      TimeLevelGodunovStep);
Timer TimeLGupdateState          ("updateState",     TimeLevelGodunovStep, 178);
Timer TimeLGincrementFluxRegister("inc flux reg",    TimeLevelGodunovStep);
Timer TimeLGtempBarrier          ("temp Barrier",    TimeLevelGodunovStep);
Timer TimeLGcopyUandAllreduce    ("copyU Allreduce", TimeLevelGodunovStep);

Timer TimeUpstateInit              ("Init",           TimeLGupdateState);
Timer TimeUpstateComputeWHalf      ("computeWHalf",   TimeLGupdateState, 179);
Timer TimeUpstateComputeUpdate     ("computeUpdate",  TimeLGupdateState, 180);
Timer TimeUpstateMaxWaveSpeed      ("getMaxWaveSpeed",TimeLGupdateState);

Timer TimeCWH_boxSetup             ("box setup",      TimeUpstateComputeWHalf);
Timer TimeCWH_aUcopy               ("a_U copy",       TimeUpstateComputeWHalf);
Timer TimeCWH_consToPrim           ("consToPrim",     TimeUpstateComputeWHalf);
Timer TimeCWH_flattening           ("flattening",     TimeUpstateComputeWHalf);
Timer TimeCWH_PPMNormalPred        ("PPMNormalPred",  TimeUpstateComputeWHalf);
Timer TimeCWH_addSourceTerm        ("add src term",   TimeUpstateComputeWHalf);
Timer TimeCWH_solveRiemann         ("solve Riemann",  TimeUpstateComputeWHalf);
Timer TimeCWH_getFlux              ("getFlux",        TimeUpstateComputeWHalf);
Timer TimeCWH_3DintermediateFluxes ("3DintermedFlux", TimeUpstateComputeWHalf);
Timer TimeCWH_boxSurroundingNodes  ("box surrNodes",  TimeUpstateComputeWHalf);
Timer TimeCWH_2DfinalFluxCorrection("2DfinalFluxCorr",TimeUpstateComputeWHalf);
Timer TimeCWH_3DfinalFluxCorrection("3DfinalFluxCorr",TimeUpstateComputeWHalf);
Timer TimeCWH_finalRiemann         ("final Riemann",  TimeUpstateComputeWHalf);

Timer TimeCUadUzero                 ("a_dU zero",     TimeUpstateComputeUpdate);
Timer TimeCUgetFlux                 ("getFlux",       TimeUpstateComputeUpdate);
Timer TimeCUconsToPrim              ("consToPrim",    TimeUpstateComputeUpdate);
Timer TimeCUdivVel                  ("divVel",        TimeUpstateComputeUpdate);
Timer TimeCUfaceBoxCalc             ("faceBox calc",  TimeUpstateComputeUpdate);
Timer TimeCUartificialViscosity     ("artificialVis", TimeUpstateComputeUpdate);
Timer TimeCUartViscBC               ("artViscBC",     TimeUpstateComputeUpdate);
Timer TimeCUfluxDiff                ("flux diff",     TimeUpstateComputeUpdate);
Timer TimeCUmultiplyBydtdx          ("multiplyBydtdx",TimeUpstateComputeUpdate);

Timer TMPI_LGstep_cp1                 ("stepa_U cp",      Everything, DTIMECOMM, true);
Timer TMPI_LGAllreduce                ("step Allreduce",  Everything, DTIMECOMM, true);
Timer TMPI_LGgetMaxWaveSpeed_gather   ("maxspeed gather", Everything, DTIMECOMM, true);
Timer TMPI_LGgetMaxWaveSpeed_broadcast("maxspeed bc",     Everything, DTIMECOMM, true);
Timer TMPI_gov_computeSum_Allreduce   ("gov compSum Allr",Everything, DTIMECOMM, true);

Timer TF_GETGRAD         ("GETGRAD",        Everything, DTIMEFORT, true);
Timer TF_GETDPTWO        ("GETDPTWO",       Everything, DTIMEFORT, true);
Timer TF_MIN3PTS         ("MIN3PTS",        Everything, DTIMEFORT, true);
Timer TF_GETFLAT         ("GETFLAT",        Everything, DTIMEFORT, true);
Timer TF_MINFLAT         ("MINFLAT",        Everything, DTIMEFORT, true);
Timer TF_SECONDSLOPEDIFFS("2ndSLOPEDIFFS",  Everything, DTIMEFORT, true);
Timer TF_FOURTHSLOPEDIFFS("4thSLOPEDIFFS",  Everything, DTIMEFORT, true);
Timer TF_ARTVISC         ("ARTVISC",        Everything, DTIMEFORT, true);
Timer TF_VANLEERLIMITER  ("VANLEERLIMITER", Everything, DTIMEFORT, true);
Timer TF_DIVUEDGE        ("DIVUEDGE",       Everything, DTIMEFORT, true);
Timer TF_PPMFACE         ("PPMFACE",        Everything, DTIMEFORT, true);
Timer TF_PPMLIMITER      ("PPMLIMITER",     Everything, DTIMEFORT, true);
Timer TF_PPMPRED         ("PPMPRED",        Everything, DTIMEFORT, true);
Timer TF_PLMPRED         ("PLMPRED",        Everything, DTIMEFORT, true);
Timer TF_FLUXDIFF        ("FLUXDIFF",       Everything, DTIMEFORT, true);
