#include "localfunctions.H"
#include "tdglFF.H"

#include "BoxIterator.H"
#include "LayoutIterator.H"
#include "MeshRefineObject.H"
#include "FineInterp.H"


/*
  Set RHS on hierarchy from input file
 */
int setRHS(Vector<LevelData<FArrayBox>* >& vectRhs,
           Vector<Real>&                  vectDx, 
           Vector<Box>&                  vectDomain, 
           int numlevels, bool verbose) {

  Real rhono, rno;
  int iprob;

  iprob = 0;
  rhono = 0.75;
  rno = 0.5;
  //if(verbose)
  //pout() 
  //  << " rhono  = " << rhono
  //  << " rno  = " << rno
  //  << " iprob  = " << iprob
  //  << endl;
  for(int ilev = 0; ilev < numlevels; ilev++) {
    //if(verbose)
    //  pout() 
    //    << " ilev = " << ilev 
    //    << " dom = " << vectDomain[ilev]
    //    << " dx  = " << vectDx[ilev]
    //  << endl;
    Real dxlev = vectDx[ilev];
    Box domlev =vectDomain[ilev];
    LevelData<FArrayBox>& rhsLD = *vectRhs[ilev];
    DataIterator dit =  rhsLD.dataIterator();
    for(dit.reset(); dit.ok(); ++dit)  {
      FArrayBox& rhsFab = rhsLD[dit()];
      //kluge to get things the same in 0.2
      rhsFab.setVal(7.0);

      FORT_GETRHSPOIS(CHF_FRA(rhsFab),
                      CHF_BOX(rhsFab.box()),
                      CHF_BOX(domlev),
                      CHF_CONST_REAL(dxlev),
                      CHF_CONST_REAL(rhono),
                      CHF_CONST_REAL(rno),
                      CHF_CONST_INT(iprob));
    }
    
  }

  return 0;
}
