#ifndef _tdglF_F_H_
#define _tdglF_F_H_

#include "FORT_PROTO.H"
#include "REAL.H"

extern "C"
{

// Prototype for Fortran procedure setrhs ...
//
#define FORT_SETRHS FORTRAN_NAME( SETRHS ,setrhs )
void 
FORT_SETRHS(
      CHFp_FRA(rhs)
      ,CHFp_BOX(box)
      ,CHFp_CONST_REAL(dx) );

// Prototype for Fortran procedure setphi ...
//
#define FORT_SETPHI FORTRAN_NAME( SETPHI ,setphi )
void 
FORT_SETPHI(
      CHFp_FRA(phi)
      ,CHFp_BOX(box)
      ,CHFp_CONST_REAL(dx) );

// Prototype for Fortran procedure random ...
//
#define FORT_RANDOM FORTRAN_NAME( RANDOM ,random )
void 
FORT_RANDOM(
      CHFp_INT(idum)
      ,CHFp_REAL(ran1) );

// Prototype for Fortran procedure DVDPHI ...
//
#define FORT_DVDPHI FORTRAN_NAME( DVDPHI ,dvdphi )
void 
FORT_DVDPHI(
      CHFp_REAL(vphi)
      ,CHFp_REAL(a_phi) );

// Prototype for Fortran procedure SETUPRHS ...
//
#define FORT_SETUPRHS FORTRAN_NAME( SETUPRHS ,setuprhs )
void 
FORT_SETUPRHS(
      CHFp_FRA(rhs)
      ,CHFp_CONST_FRA(phi)
      ,CHFp_CONST_FRA(phihalf)
      ,CHFp_CONST_FRA(lphi)
      ,CHFp_BOX(region)
      ,CHFp_CONST_REAL(dx)
      ,CHFp_CONST_REAL(dt) );

// Prototype for Fortran procedure HELMHOLTZOP ...
//
#define FORT_HELMHOLTZOP FORTRAN_NAME( HELMHOLTZOP ,helmholtzop )
void 
FORT_HELMHOLTZOP(
      CHFp_FRA(hofphi)
      ,CHFp_CONST_FRA(phi)
      ,CHFp_BOX(region)
      ,CHFp_CONST_REAL(dx)
      ,CHFp_CONST_REAL(alpha) );

// Prototype for Fortran procedure PREDICTPHI ...
//
#define FORT_PREDICTPHI FORTRAN_NAME( PREDICTPHI ,predictphi )
void 
FORT_PREDICTPHI(
      CHFp_FRA(phihalf)
      ,CHFp_CONST_FRA(phi)
      ,CHFp_CONST_FRA(lphi)
      ,CHFp_BOX(region)
      ,CHFp_CONST_REAL(dx)
      ,CHFp_CONST_REAL(dt) );

// Prototype for Fortran procedure GETGRAD ...
//
#define FORT_GETGRAD FORTRAN_NAME( GETGRAD ,getgrad )
void 
FORT_GETGRAD(
      CHFp_BOX(dInterior)
      ,CHFp_BOX(loedge)
      ,CHFp_BOX(hiedge)
      ,CHFp_CONST_INT(idir)
      ,CHFp_CONST_INT(haslo)
      ,CHFp_CONST_INT(hashi)
      ,CHFp_CONST_FRA1(q)
      ,CHFp_FRA1(dq) );

// Prototype for Fortran procedure MAGNITUDE ...
//
#define FORT_MAGNITUDE FORTRAN_NAME( MAGNITUDE ,magnitude )
void 
FORT_MAGNITUDE(
      CHFp_BOX(b)
      ,CHFp_FRA1(mag)
      ,CHFp_CONST_FRA(data) );

}
#endif
