#!/usr/bin/tcsh
# usage :  run through ssh-agent and the poorcron.sh as such
#
# > ssh-agent poorcron.sh 18000 regression.sh 86400
#
# 18000 is how many seconds you want a delay before the
# first build starts, the 86400 is how many seconds between
# builds


cvs update

make dist-regression

rm regression/*
echo '#########  colella  #########' 
echo '#########  colella  #########' > regression/colella
date >> regression/colella
scp regression.tar.gz bvs@colella:/tmp/regression.tar.gz
ssh colella 'cd /tmp ; gunzip -f regression.tar.gz ; tar xf regression.tar'
ssh colella 'cd /tmp/Chombo/lib; make run CXX=KCC FC=pgf77 DEBUG=FALSE' >>& regression/colella

#echo '#########  mothra  #########' 
#echo '#########  mothra  #########' > regression/mothra
#date >> regression/mothra
#ssh mothra 'cd Chombo/lib; make run DIM=3 DEBUG=FALSE' >> regression/mothra

echo '#########  newton.nersc.gov  #########' 
echo '#########  newton.nersc.gov  #########' > regression/newton.nersc.gov
date >> regression/newton.nersc.gov
scp regression.tar.gz bvs@newton.nersc.gov:regression.tar.gz
ssh newton.nersc.gov 'gunzip -f regression.tar.gz ; tar xf regression.tar'
ssh newton.nersc.gov 'cd Chombo/lib; make run DIM=3 DEBUG=FALSE' >>& regression/newton.nersc.gov

echo '#########  mcurie.nersc.gov  #########' 
echo '#########  mcurie.nersc.gov  #########' > regression/mcurie.nersc.gov
date >> regression/mcurie.nersc.gov
scp regression.tar.gz bvs@newton.nersc.gov:regression.tar.gz
ssh mcurie.nersc.gov 'gunzip -f regression.tar.gz ; tar xf regression.tar'
ssh mcurie.nersc.gov 'cd Chombo/lib; make run DIM=3 DEBUG=FALSE' >>& regression/mcurie.nersc.gov

echo '#########  n2001  #########' 
echo '#########  n2001  #########' > regression/n2001
date >> regression/n2001
scp regression.tar.gz bvs@n2001.lbl.gov:regression.tar.gz
ssh n2001.lbl.gov 'gunzip -f regression.tar.gz ; tar xf regression.tar'
ssh n2001.lbl.gov 'cd Chombo/lib ;     make run   DIM=3 DEBUG=TRUE'  >>& regression/n2001
ssh n2001.lbl.gov 'cd Chombo/lib; make run   DIM=3 DEBUG=FALSE' >>& regression/n2001

echo '#########  n2001.parallel  #########' 
echo '#########  n2001.parallel  #########' > regression/n2001
ssh n2001.lbl.gov 'cd Chombo/lib ;     make lib   DIM=2 DEBUG=FALSE MPI=TRUE' >>& regression/n2001
#ssh n2001.lbl.gov 'cd 4nodes; qsub batchfile'
#scp bvs@n2001:4nodes/diff_file   regression/n2001.diff_file
#scp bvs@n2001:4nodes/old.results regression/n2001.old_results


echo '#########  gseaborg  #########' 
echo '#########  gseaborg  #########' > regression/gseaborg
date >> regression/gseaborg
scp -L regression.tar.gz bvs@gseaborg.nersc.gov:regression.tar.gz
ssh -P gseaborg.nersc.gov 'gunzip -f regression.tar.gz ; tar xf regression.tar'
ssh -P gseaborg.nersc.gov 'cd Chombo/lib ; make run DIM=3 DEBUG=FALSE MPI=TRUE' >>& regression/gseaborg
#ssh -P gseaborg.nersc.gov 'llsubmit 4nodes/batchfile'
#ssh -P gseaborg.nersc.gov 'cat 4nodes/regression.err ; cat 4nodes/results' >>& regression/gseaborg


