#include "Timer.H"
extern Timer Everything;
extern Timer TimeTSadvance;

Timer TimeLevelGodunovStep("LevelGodunovStep", TimeTSadvance, 176);

Timer TimeLGtemporaryStorage     ("tempStorage",     TimeLevelGodunovStep);
Timer TimeLGfillInterp           ("fillInterp",      TimeLevelGodunovStep);
Timer TimeLGupdateState          ("updateState",     TimeLevelGodunovStep, 178);
Timer TimeLGincrementFluxRegister("inc flux reg",    TimeLevelGodunovStep);
Timer TimeLGtempBarrier          ("temp Barrier",    TimeLevelGodunovStep);
Timer TimeLGcopyUandAllreduce    ("copyU Allreduce", TimeLevelGodunovStep);

Timer TimeUpstateInit              ("Init",           TimeLGupdateState);
Timer TimeUpstateComputeWHalf      ("computeWHalf",   TimeLGupdateState, 179);
Timer TimeUpstateComputeUpdate     ("computeUpdate",  TimeLGupdateState, 180);
Timer TimeUpstateMaxWaveSpeed      ("getMaxWaveSpeed",TimeLGupdateState);

Timer TimeCWH_boxSetup             ("box setup",      TimeUpstateComputeWHalf);
Timer TimeCWH_aUcopy               ("a_U copy",       TimeUpstateComputeWHalf);
Timer TimeCWH_consToPrim           ("consToPrim",     TimeUpstateComputeWHalf);
Timer TimeCWH_flattening           ("flattening",     TimeUpstateComputeWHalf);
Timer TimeCWH_incSource            ("inc Source",     TimeUpstateComputeWHalf);
Timer TimeCWH_PPMNormalPred        ("PPMNormalPred",  TimeUpstateComputeWHalf);
Timer TimeCWH_addSourceTerm        ("add src term",   TimeUpstateComputeWHalf);
Timer TimeCWH_solveRiemann         ("solve Riemann",  TimeUpstateComputeWHalf);
Timer TimeCWH_getFlux              ("getFlux",        TimeUpstateComputeWHalf);
Timer TimeCWH_3DintermediateFluxes ("3DintermedFlux", TimeUpstateComputeWHalf);
Timer TimeCWH_boxSurroundingNodes  ("box surrNodes",  TimeUpstateComputeWHalf);
Timer TimeCWH_2DfinalFluxCorrection("2DfinalFluxCorr",TimeUpstateComputeWHalf);
Timer TimeCWH_3DfinalFluxCorrection("3DfinalFluxCorr",TimeUpstateComputeWHalf);
Timer TimeCWH_finalRiemann         ("final Riemann",  TimeUpstateComputeWHalf);

Timer TimeCUadUzero                 ("a_dU zero",     TimeUpstateComputeUpdate);
Timer TimeCUgetFlux                 ("getFlux",       TimeUpstateComputeUpdate);
Timer TimeCUconsToPrim              ("consToPrim",    TimeUpstateComputeUpdate);
Timer TimeCUdivVel                  ("divVel",        TimeUpstateComputeUpdate);
Timer TimeCUfaceBoxCalc             ("faceBox calc",  TimeUpstateComputeUpdate);
Timer TimeCUartificialViscosity     ("artificialVis", TimeUpstateComputeUpdate);
Timer TimeCUartViscBC               ("artViscBC",     TimeUpstateComputeUpdate);
Timer TimeCUfluxDiff                ("flux diff",     TimeUpstateComputeUpdate);
Timer TimeCUmultiplyBydtdx          ("multiplyBydtdx",TimeUpstateComputeUpdate);

Timer TMPI_LGstep_cp1                 ("stepa_U cp",      Everything, DTIMECOMM, true);
Timer TMPI_LGAllreduce                ("step Allreduce",  Everything, DTIMECOMM, true);
Timer TMPI_LGgetMaxWaveSpeed_gather   ("maxspeed gather", Everything, DTIMECOMM, true);
Timer TMPI_LGgetMaxWaveSpeed_broadcast("maxspeed bc",     Everything, DTIMECOMM, true);
Timer TMPI_gov_computeSum_Allreduce   ("gov compSum Allr",Everything, DTIMECOMM, true);

Timer TF_GETGRADF         ("GETGRADF", Everything, DTIMEFORT, true);
Timer TF_GETDPTWOF        ("GETDPTWOF", Everything, DTIMEFORT, true);
Timer TF_MIN3PTSF         ("MIN3PTSF", Everything, DTIMEFORT, true);
Timer TF_GETFLATF         ("GETFLATF", Everything, DTIMEFORT, true);
Timer TF_MINFLATF         ("MINFLATF", Everything, DTIMEFORT, true);
Timer TF_FOURTHSLOPEDIFFSF("FOURTHSLOPEDIFFSF", Everything, DTIMEFORT, true);
Timer TF_SECONDSLOPEDIFFSF("SECONDSLOPEDIFFSF", Everything, DTIMEFORT, true);
Timer TF_VANLEERLIMITERF  ("VANLEERLIMITERF", Everything, DTIMEFORT, true);
Timer TF_PLMNORMALPREDF   ("PLMNORMALPREDF", Everything, DTIMEFORT, true);
Timer TF_PPMFACEVALUESF   ("PPMFACEVALUESF", Everything, DTIMEFORT, true);
Timer TF_PPMLIMITERF      ("PPMLIMITERF", Everything, DTIMEFORT, true);
Timer TF_PPMNORMALPREDF   ("PPMNORMALPREDF", Everything, DTIMEFORT, true);
Timer TF_DIVUEDGEF        ("DIVUEDGEF", Everything, DTIMEFORT, true);
Timer TF_ARTVISCF         ("ARTVISCF", Everything, DTIMEFORT, true);
Timer TF_FLUXDIFF         ("FLUXDIFF", Everything, DTIMEFORT, true);
