/*   _______              __
    / ___/ /  ___  __ _  / /  ___
   / /__/ _ \/ _ \/  V \/ _ \/ _ \
   \___/_//_/\___/_/_/_/_.__/\___/
*/
// CHOMBO Copyright (c) 2000-2004, The Regents of the University of
// California, through Lawrence Berkeley National Laboratory (subject to
// receipt of any required approvals from U.S. Dept. of Energy).  All
// rights reserved.
//
// Redistribution and use in source and binary forms, with or without
// modification, are permitted provided that the following conditions are met:
//
// (1) Redistributions of source code must retain the above copyright
// notice, this list of conditions and the following disclaimer.
// (2) Redistributions in binary form must reproduce the above copyright
// notice, this list of conditions and the following disclaimer in the
// documentation and/or other materials provided with the distribution.
// (3) Neither the name of Lawrence Berkeley National Laboratory, U.S.
// Dept. of Energy nor the names of its contributors may be used to endorse
// or promote products derived from this software without specific prior
// written permission.
//
// THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS
// "AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED
// TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A
// PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT OWNER
// OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL,
// EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO,
// PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR
// PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF
// LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING
// NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS
// SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
//
// You are under no obligation whatsoever to provide any bug fixes,
// patches, or upgrades to the features, functionality or performance of
// the source code ("Enhancements") to anyone; however, if you choose to
// make your Enhancements available either publicly, or directly to
// Lawrence Berkeley National Laboratory, without imposing a separate
// written license agreement for such Enhancements, then you hereby grant
// the following license: a non-exclusive, royalty-free perpetual license
// to install, use, modify, prepare derivative works, incorporate into
// other computer software, distribute, and sublicense such Enhancements or
// derivative works thereof, in binary and source code form.
//
// TRADEMARKS. Product and company names mentioned herein may be the
// trademarks of their respective owners.  Any rights not expressly granted
// herein are reserved.
//

#include "parstream.H"
#include <iostream>
using std::cout;
using std::cerr;
using std::endl;
void dumpAllThoseCrazyDefines(void) {

#ifdef TIMER
  pout() << "TIMER (Timers On)" << endl;
#endif
#ifdef OPT_UNROLL_SPACEDIM_LOOP
  pout() << "OPT_UNROLL_SPACEDIM_LOOP" << endl;
#endif
#ifdef OPT_BVS_ALLOCATEBUFFERS
  pout() << "OPT_BVS_ALLOCATEBUFFERS" << endl;
#endif
#ifdef OPT_BVS_PACKED
  pout() << "OPT_BVS_PACKED" << endl;
#endif
#ifdef OPT_BVS_LOADBALANCE_PHASE3
  pout() << "OPT_BVS_LOADBALANCE_PHASE3" << endl;
#endif
#ifdef OPT_BVS_LOADBALANCE_NEW
  pout() << "OPT_BVS_LOADBALANCE_NEW" << endl;
#endif
#ifdef OPT_QUAD_INTERPONIVS
  pout() << "OPT_QUAD_INTERPONIVS" << endl;
#endif
#ifdef OPT_NO_ISDISJOINT
  pout() << "OPT_NO_ISDISJOINT" << endl;
#endif
#ifdef OPT_DO_NORM_ONCE
  pout() << "OPT_DO_NORM_ONCE" << endl;
#endif
#ifdef OPT_MV_GSRBLEVELLAP_LOOP
  pout() << "OPT_MV_GSRBLEVELLAP_LOOP" << endl;
#endif
#ifdef OPT_MYPERFORMCOPY
  pout() << "OPT_MYPERFORMCOPY" << endl;
#endif
#ifdef OPT_LOADBALANCE_DYNAMICGOAL
  pout() << "OPT_LOADBALANCE_DYNAMICGOAL" << endl;
#endif
#ifdef OPT_BVS_LINEAR
  pout() << "OPT_BVS_LINEAR" << endl;
#endif
#ifdef USE_MYEXCHANGE_IN_POISSONOP
  pout() << "USE_MYEXCHANGE_IN_POISSONOP" << endl;
#endif
#ifdef USE_DAN_LS_CONV_TEST
  pout() << "USE_DAN_LS_CONV_TEST" << endl;
#endif
#ifdef OPT_MERGE_FORTRAN_LOOPS
  pout() << "OPT_MERGE_FORTRAN_LOOPS" << endl;
#endif
#ifdef OPT_BVS_CACHE_MAKE_PNDS
  pout() << "OPT_BVS_CACHE_MAKE_PNDS" << endl;
#endif
#ifdef OPT_BVS_INSIDE_MAKE_PNDS
  pout() << "OPT_BVS_INSIDE_MAKE_PNDS" << endl;
#endif
#ifdef OPT_BVS_GRANULARITY
  pout() << "OPT_BVS_GRANULARITY=" << OPT_BVS_GRANULARITY << endl;
#endif
#ifdef OPT_BVS_TREE
  pout() << "OPT_BVS_TREE" << endl;
#endif
#ifdef OPT_BVS_MAKE_BOXES_PARALLEL
  pout() << "OPT_BVS_MAKE_BOXES_PARALLEL" << endl;
#endif
#ifdef REDUCE_MAXSWAPITERATIONS
  pout() << "REDUCE_MAXSWAPITERATIONS" << endl;
#endif
#ifdef USE_FP_CONSISTENT_DP
  pout() << "USE_FP_CONSISTENT_DP" << endl;
#endif

#ifdef NEW_ADVECTION
  pout() << "NEW_ADVECTION" << endl;
#endif
#ifdef OPT_AVERAGE
  pout() << "OPT_AVERAGE" << endl;
#endif
#ifdef OPT_BOXGHOSTBC
  pout() << "OPT_BOXGHOSTBC" << endl;
#endif
#ifdef USE_RELAXATION_IN_GSRB
  pout() << "USE_RELAXATION_IN_GSRB" << endl;
#endif
#ifdef OPT_NO_INIT_SETVAL
  pout() << "OPT_NO_INIT_SETVAL" << endl;
#endif
#ifdef OPT_POLYKSUM
  pout() << "OPT_POLYKSUM" << endl;
#endif

#ifdef COUNT_PEX
  pout() << "COUNT_PEX" << endl;
#endif
#ifdef WRITE_TITA_FILES
  pout() << "WRITE_TITA_FILES" << endl;
#endif
#ifdef TRAP_FPE
  pout() << "TRAP_FPE on" << endl;
#endif

#ifdef TIMED_BARR
  pout() << "TIMED_BARR" << endl;
#endif

#ifdef HYPRE
  pout() << "HYPRE" << endl;
#endif

}
