/*   _______              __
    / ___/ /  ___  __ _  / /  ___
   / /__/ _ \/ _ \/  V \/ _ \/ _ \
   \___/_//_/\___/_/_/_/_.__/\___/
*/
// CHOMBO Copyright (c) 2000-2004, The Regents of the University of
// California, through Lawrence Berkeley National Laboratory (subject to
// receipt of any required approvals from U.S. Dept. of Energy).  All
// rights reserved.
//
// Redistribution and use in source and binary forms, with or without
// modification, are permitted provided that the following conditions are met:
//
// (1) Redistributions of source code must retain the above copyright
// notice, this list of conditions and the following disclaimer.
// (2) Redistributions in binary form must reproduce the above copyright
// notice, this list of conditions and the following disclaimer in the
// documentation and/or other materials provided with the distribution.
// (3) Neither the name of Lawrence Berkeley National Laboratory, U.S.
// Dept. of Energy nor the names of its contributors may be used to endorse
// or promote products derived from this software without specific prior
// written permission.
//
// THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS
// "AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED
// TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A
// PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT OWNER
// OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL,
// EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO,
// PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR
// PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF
// LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING
// NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS
// SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
//
// You are under no obligation whatsoever to provide any bug fixes,
// patches, or upgrades to the features, functionality or performance of
// the source code ("Enhancements") to anyone; however, if you choose to
// make your Enhancements available either publicly, or directly to
// Lawrence Berkeley National Laboratory, without imposing a separate
// written license agreement for such Enhancements, then you hereby grant
// the following license: a non-exclusive, royalty-free perpetual license
// to install, use, modify, prepare derivative works, incorporate into
// other computer software, distribute, and sublicense such Enhancements or
// derivative works thereof, in binary and source code form.
//
// TRADEMARKS. Product and company names mentioned herein may be the
// trademarks of their respective owners.  Any rights not expressly granted
// herein are reserved.
//

#ifndef _FOO_H_
#define _FOO_H_

#define foo_width 64
#define foo_height 64
static unsigned char foo_bits[] = {
   0x00, 0x40, 0x00, 0x04, 0x02, 0x60, 0x00, 0x00, 0x00, 0xc0, 0x00, 0x04,
   0x03, 0x30, 0x00, 0x00, 0x00, 0x80, 0x01, 0x04, 0x01, 0x1c, 0x00, 0x00,
   0x00, 0x00, 0x03, 0x04, 0x01, 0x02, 0x00, 0x00, 0x00, 0x00, 0x04, 0x04,
   0x01, 0x03, 0x00, 0x00, 0x00, 0x00, 0x0c, 0xff, 0x81, 0x00, 0x00, 0x00,
   0xc0, 0x00, 0xd8, 0x80, 0x41, 0x00, 0x00, 0x00, 0x80, 0x03, 0x30, 0x00,
   0x36, 0x00, 0x00, 0x00, 0x00, 0x7e, 0x08, 0x00, 0x18, 0x00, 0x00, 0x00,
   0x00, 0x80, 0x09, 0x00, 0x08, 0x00, 0x00, 0x00, 0x00, 0x00, 0x07, 0x00,
   0x10, 0x00, 0x00, 0x00, 0x00, 0x00, 0x06, 0x00, 0x10, 0x00, 0x00, 0x00,
   0x00, 0x00, 0x02, 0xe0, 0x21, 0x00, 0x00, 0x00, 0x00, 0x00, 0x02, 0x38,
   0x20, 0x00, 0x00, 0x00, 0x00, 0xe0, 0x03, 0x8c, 0x20, 0x00, 0x00, 0x00,
   0x80, 0x1f, 0x02, 0xc0, 0x20, 0x00, 0x00, 0x00, 0x70, 0x00, 0x02, 0x00,
   0x20, 0x00, 0x00, 0x00, 0x08, 0x00, 0x02, 0x00, 0x20, 0x00, 0x00, 0x00,
   0x00, 0x00, 0x03, 0x00, 0x20, 0x00, 0x00, 0x02, 0x00, 0x80, 0x04, 0x00,
   0x10, 0x00, 0x00, 0x0f, 0x00, 0x40, 0x04, 0x00, 0x10, 0x00, 0xc0, 0x38,
   0x00, 0x20, 0x08, 0x1c, 0x08, 0x00, 0x60, 0x30, 0x00, 0x10, 0x08, 0xe0,
   0x0b, 0x00, 0x20, 0x10, 0x00, 0x08, 0x30, 0x00, 0x06, 0x00, 0x30, 0x08,
   0x00, 0x04, 0xc0, 0x80, 0x01, 0x00, 0x0c, 0x0c, 0x00, 0x02, 0x00, 0x7f,
   0x00, 0x00, 0x86, 0x07, 0x00, 0x01, 0x40, 0x00, 0x01, 0x78, 0xc3, 0x00,
   0x80, 0x00, 0x40, 0x00, 0x01, 0xff, 0x61, 0x00, 0x40, 0x00, 0x40, 0x00,
   0xe1, 0x7f, 0x30, 0x00, 0x60, 0x00, 0x20, 0x00, 0xfd, 0x3f, 0x18, 0x00,
   0x00, 0x00, 0x20, 0x00, 0xff, 0x8f, 0x05, 0x00, 0x00, 0x00, 0x20, 0x00,
   0xfe, 0x07, 0x07, 0x00, 0x00, 0x00, 0x60, 0x00, 0xfe, 0xa3, 0x07, 0x00,
   0x00, 0x00, 0x70, 0x00, 0x8e, 0xe1, 0x03, 0x00, 0x00, 0x00, 0xfc, 0x01,
   0x4e, 0xf6, 0x01, 0x00, 0x00, 0x00, 0xfe, 0x03, 0x22, 0xfc, 0x00, 0x00,
   0x00, 0x80, 0xff, 0x00, 0x1a, 0x7c, 0x00, 0x00, 0x00, 0xc0, 0x3f, 0x00,
   0x0e, 0x12, 0x00, 0x00, 0x00, 0xf0, 0x0f, 0x80, 0x03, 0x01, 0x00, 0x00,
   0x00, 0xfc, 0x0b, 0xf0, 0x86, 0x00, 0x00, 0x00, 0x00, 0xfe, 0xc9, 0x1f,
   0x40, 0x00, 0x00, 0x00, 0x00, 0xfc, 0x77, 0x00, 0x30, 0x00, 0x00, 0x00,
   0x00, 0xf0, 0x3f, 0x00, 0x08, 0x00, 0x00, 0x00, 0x00, 0xc0, 0xff, 0x01,
   0x06, 0x00, 0x00, 0x00, 0x00, 0x00, 0xff, 0x07, 0x03, 0x00, 0x00, 0x00,
   0x00, 0x80, 0xfd, 0x9f, 0x01, 0x00, 0x00, 0x00, 0x00, 0xf0, 0xfc, 0xcf,
   0x00, 0x00, 0x00, 0x00, 0x00, 0x1c, 0x90, 0x64, 0x08, 0x00, 0x00, 0x00,
   0x00, 0x06, 0x90, 0x24, 0x08, 0x00, 0x00, 0x00, 0xc0, 0x01, 0x90, 0x11,
   0x10, 0x00, 0x00, 0x00, 0x80, 0x07, 0x30, 0x18, 0x20, 0x00, 0x00, 0x00,
   0x00, 0x4c, 0x00, 0x18, 0x40, 0x00, 0x00, 0x00, 0x00, 0x38, 0x00, 0x2c,
   0x40, 0x00, 0x00, 0x00, 0x00, 0x30, 0x00, 0x44, 0x80, 0x00, 0x00, 0x00,
   0x00, 0x68, 0x00, 0x86, 0x00, 0x01, 0x00, 0x00, 0x00, 0xc4, 0x00, 0x82,
   0x00, 0x01, 0x00, 0x00, 0x00, 0x83, 0x01, 0x01, 0x01, 0x02, 0x00, 0x00,
   0x80, 0x40, 0x83, 0x01, 0x02, 0x04, 0x00, 0x00, 0x40, 0x40, 0x86, 0x00,
   0x02, 0x04, 0x00, 0x00, 0x20, 0x60, 0x4c, 0x00, 0x04, 0x08, 0x00, 0x00,
   0x10, 0x18, 0x78, 0x00, 0x08, 0x10, 0x00, 0x00, 0x08, 0x04, 0x20, 0x00,
   0x10, 0x20, 0x00, 0x00, 0x04, 0x03, 0x00, 0x00, 0x10, 0x20, 0x00, 0x00,
   0xfe, 0x00, 0x00, 0x00, 0xe0, 0x7f, 0x00, 0x00};

#endif
