/* _______              __
  / ___/ /  ___  __ _  / /  ___
 / /__/ _ \/ _ \/  ' \/ _ \/ _ \
 \___/_//_/\___/_/_/_/_.__/\___/ 
*/

// AMRNavierStokesFactory.H

//
// This software is copyright (C) by the Lawrence Berkeley
// National Laboratory.  Permission is granted to reproduce
// this software for non-commercial purposes provided that
// this notice is left intact.
// 
// It is acknowledged that the U.S. Government has rights to
// this software under Contract DE-AC03-765F00098 between
// the U.S.  Department of Energy and the University of
// California.
//
// This software is provided as a professional and academic
// contribution for joint exchange. Thus it is experimental,
// is provided ``as is'', with no warranties of any kind
// whatsoever, no support, no promise of updates, or printed
// documentation. By using this software, you acknowledge
// that the Lawrence Berkeley National Laboratory and
// Regents of the University of California shall have no
// liability with respect to the infringement of other
// copyrights by any part of this software.
//
// Dan Martin, Fri, Jan 14, 2000

#ifndef _AMRNavierStokesFactory_H_
#define _AMRNavierStokesFactory_H_

#include "AMRNavierStokes.H"
#include "AMRLevelFactory.H"
#include "PhysBCUtil.H"

class AMRNavierStokesFactory : public AMRLevelFactory
{
public:

  ///
  AMRNavierStokesFactory();

  ///
  virtual AMRLevel* new_amrlevel() const;

  virtual
  ~AMRNavierStokesFactory();

  /// 
  void CFL(const Real a_cfl);

  /// 
  void refinementThreshold(const Real a_refine_threshold);

  /// 
  void setPhysBC(const PhysBCUtil& a_physBC);

  /// 
  void setLimitSolverCoarsening(bool a_limitSolverCoarsening);


protected:
  ///
  void setDefaultValues();

  ///
  Real m_cfl;

  ///
  Real m_refine_thresh;

  ///
  PhysBCUtil* m_physBCPtr;

  ///
  bool m_limitSolverCoarsening;
  

};

#endif


