#include <iostream>

#include "HDF5.H"
#include "AMRIO.H"

#include "Timer.H"
Timer Everything("Everything");

#ifdef TIMER
// global variables
int IterationFlavor;
int BIterationFlavor;
CounterStruct NoelsSooperIterationCounter[MAX_ITERATION_COUNTERS];
#endif

void readData(LevelData<FArrayBox> & a_rhs,
              Vector<LevelData<FArrayBox>* >& a_piVect,
              Vector<LevelData<FArrayBox>* >& a_velVect,
              ProblemDomain& a_domain,
              Real& a_dx, 
              int& a_nRefCrse,
              const string& a_filename);
              
int main(int argc, char* argv[]) {
  
  char* filename = NULL;
  
  for (int i=1; i<argc; i++) {
    if (strlen(argv[i]) > 0 && argv[i][0] != '-') {
      filename = argv[i];
      argv[i] = "";
      break;
    }
  }
  
  LevelData<FArrayBox> rhs;
  Vector<LevelData<FArrayBox>* > piVect(2);
  Vector<LevelData<FArrayBox>* > velVect(2);
  ProblemDomain domain;
  Real dx;
  int nRefCrse;
  
  string fname(filename);
  readData(rhs, piVect, velVect, domain, dx, nRefCrse, fname);


  // must delete memory yourself?

}

void 
readData(LevelData<FArrayBox> & a_rhs,
         Vector<LevelData<FArrayBox>* >& a_piVect,
         Vector<LevelData<FArrayBox>* >& a_velVect,
         ProblemDomain& a_domain,
         Real& a_dx, 
         int& a_nRefCrse,
         const string& a_filename)
{
  Vector<DisjointBoxLayout> vectGrids;
  Vector<LevelData<FArrayBox>*> vectData;
  Vector<string> vectNames;
  Real dt, time;
  Vector<int> nRefVect;
  int numLevels;
  IntVect ghostVect(IntVect::TheZeroVector());
  Box domainBox;

  ReadAMRHierarchyHDF5(a_filename,
                       vectGrids, 
                       vectData,
                       vectNames,
                       domainBox,
                       a_dx,
                       dt,
                       time,
                       nRefVect,
                       numLevels,
                       ghostVect);
}
