/* _______              __
  / ___/ /  ___  __ _  / /  ___
 / /__/ _ \/ _ \/  ' \/ _ \/ _ \
 \___/_//_/\___/_/_/_/_.__/\___/ 
*/

// CellToEdge.H

//
// This software is copyright (C) by the Lawrence Berkeley
// National Laboratory.  Permission is granted to reproduce
// this software for non-commercial purposes provided that
// this notice is left intact.
// 
// It is acknowledged that the U.S. Government has rights to
// this software under Contract DE-AC03-765F00098 between
// the U.S.  Department of Energy and the University of
// California.
//
// This software is provided as a professional and academic
// contribution for joint exchange. Thus it is experimental,
// is provided ``as is'', with no warranties of any kind
// whatsoever, no support, no promise of updates, or printed
// documentation. By using this software, you acknowledge
// that the Lawrence Berkeley National Laboratory and
// Regents of the University of California shall have no
// liability with respect to the infringement of other
// copyrights by any part of this software.
//
// Dan Martin, Fri, Jan 14, 2000

#ifndef _CellToEdge_H_
#define _CellToEdge_H_

#include "LevelData.H"
#include "FArrayBox.H"
#include "FluxBox.H"

///
void CellToEdge(const LevelData<FArrayBox>& a_cellData,
		LevelData<FluxBox>& a_edgeData);

///
void CellToEdge(const FArrayBox& a_cellData,
		FluxBox& a_edgeData);


/// this one does a single direction
void CellToEdge(const FArrayBox& a_cellData, 
		FArrayBox& a_edgeData, const int a_dir);


/// this one does a single direction and component
void CellToEdge(const FArrayBox& a_cellData, const int a_cellComp,
		FArrayBox& a_edgeData, const int a_edgeComp,
		const int a_dir);

#endif


