/* _______              __
  / ___/ /  ___  __ _  / /  ___
 / /__/ _ \/ _ \/  ' \/ _ \/ _ \
 \___/_//_/\___/_/_/_/_.__/\___/ 
*/

// EdgeToCell.H

//
// This software is copyright (C) by the Lawrence Berkeley
// National Laboratory.  Permission is granted to reproduce
// this software for non-commercial purposes provided that
// this notice is left intact.
// 
// It is acknowledged that the U.S. Government has rights to
// this software under Contract DE-AC03-765F00098 between
// the U.S.  Department of Energy and the University of
// California.
//
// This software is provided as a professional and academic
// contribution for joint exchange. Thus it is experimental,
// is provided ``as is'', with no warranties of any kind
// whatsoever, no support, no promise of updates, or printed
// documentation. By using this software, you acknowledge
// that the Lawrence Berkeley National Laboratory and
// Regents of the University of California shall have no
// liability with respect to the infringement of other
// copyrights by any part of this software.
//
// Dan Martin, Fri, Jan 14, 2000

#ifndef _EdgeToCell_H_
#define _EdgeToCell_H_

#include "LevelData.H"
#include "FArrayBox.H"
#include "FluxBox.H"

/// averages cell-centered cellData to edge-centered edgeData 
void EdgeToCell(const LevelData<FluxBox>& a_edgeData,
		LevelData<FArrayBox>& a_cellData);
/** averages cell-centered cellData to SpaceDim-dimensioned 
    EdgeData -- assumes all boundary conditions already set.
    Does this for all grids. */

/// averages cellData->edgeData (all directions) for one FAB
void EdgeToCell(const FluxBox& a_edgeData,
		FArrayBox& a_cellData);


/// averages cellData->edgeData in 1 direction, for one component in a FAB
void EdgeToCell(const FluxBox& a_edgeData, const int a_edgeComp,
		FArrayBox& a_cellData, const int a_cellComp, const int a_dir);



#endif


