#ifndef _GRADIENTF_F_H_
#define _GRADIENTF_F_H_

#include "FORT_PROTO.H"
#include "REAL.H"

extern "C"
{

// Prototype for Fortran procedure NEWMACGRAD ...
//
#define FORT_NEWMACGRAD FORTRAN_NAME( NEWMACGRAD ,newmacgrad )
void 
FORT_NEWMACGRAD(
      CHFp_FRA1(edgeGrad)
      ,CHFp_CONST_FRA1(phi)
      ,CHFp_BOX(edgeGrid)
      ,CHFp_CONST_REAL(dx)
      ,CHFp_INT(dir)
      ,CHFp_INT(edgeDir) );

// Prototype for Fortran procedure MACGRAD ...
//
#define FORT_MACGRAD FORTRAN_NAME( MACGRAD ,macgrad )
void 
FORT_MACGRAD(
      CHFp_FRA1(edgeGrad)
      ,CHFp_CONST_FRA1(phi)
      ,CHFp_BOX(edgeGrid)
      ,CHFp_CONST_REAL(dx)
      ,CHFp_INT(dir)
      ,CHFp_INT(edgeDir)
      ,CHFp_BOX(BLcornerBox)
      ,CHFp_BOX(BRcornerBox)
      ,CHFp_BOX(ULcornerBox)
      ,CHFp_BOX(URcornerBox) );

// Prototype for Fortran procedure CRSEONESIDEGRAD ...
//
#define FORT_CRSEONESIDEGRAD FORTRAN_NAME( CRSEONESIDEGRAD ,crseonesidegrad )
void 
FORT_CRSEONESIDEGRAD(
      CHFp_FRA1(edgeGrad)
      ,CHFp_FIA1(mask)
      ,CHFp_BOX(loEdgeBox)
      ,CHFp_BOX(hiEdgeBox)
      ,CHFp_INT(dir)
      ,CHFp_INT(doLo)
      ,CHFp_INT(doHi) );

// Prototype for Fortran procedure GRADCC ...
//
#define FORT_GRADCC FORTRAN_NAME( GRADCC ,gradcc )
void 
FORT_GRADCC(
      CHFp_FRA1(gradPhi)
      ,CHFp_CONST_FRA1(phi)
      ,CHFp_BOX(gridBox)
      ,CHFp_CONST_REAL(dx)
      ,CHFp_INT(dir) );

}

#endif
